'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _plurallTexts = require('plurall-texts');

var _plurallIcons = require('plurall-icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false,
      selected: _this.props.list[0].label
    }, _this.handleDocumentClick = function (evt) {
      var area = _this.selector;
      if (area && evt.target && !area.contains(evt.target)) {
        _this.setState({ open: false });
      }
    }, _this.openOrClose = function () {
      if (!_this.state.open) {
        _this.setState({ open: true, fadein: true, fadeout: false });
      } else {
        _this.setState({ fadeout: true, fadein: false });
        setTimeout(function () {
          _this.setState({ open: false });
        }, 200);
      }
    }, _this.selectedItem = function (l) {
      _this.setState({ selected: l.label });
      _this.openOrClose();
      if (_this.state.open) {
        _this.props.onClick(l.value);
      }
    }, _this.close = function () {
      _this.openOrClose();
      _this.props.onClick('');
    }, _this.textSelectedColor = function () {
      if (_this.state.open) {
        return _this.props.itemsColorSelected;
      }

      if (_this.state.selected !== _this.props.list[0].label) {
        return '#FFF';
      }

      return _this.props.itemsColor;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.body.addEventListener('click', this.handleDocumentClick);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var color = this.textSelectedColor();
      var _props = this.props,
          itemsColorSelected = _props.itemsColorSelected,
          itemsColor = _props.itemsColor,
          list = _props.list;
      var _state = this.state,
          selected = _state.selected,
          open = _state.open,
          fadeout = _state.fadeout,
          fadein = _state.fadein;

      var isDropdownSelected = selected !== list[0].label && !open;
      return _react2.default.createElement(
        'div',
        { ref: function ref(e) {
            _this2.selector = e;
          }, className: _style2.default.dynamic([['2258481739', [_this2.props.itemsColorSelected, _this2.props.itemsColor]]]) + ' ' + 'holder'
        },
        _react2.default.createElement(
          'div',
          {
            onClick: function onClick() {
              return _this2.selectedItem(list[0]);
            },
            className: _style2.default.dynamic([['2258481739', [_this2.props.itemsColorSelected, _this2.props.itemsColor]]]) + ' ' + ('label box ' + (open ? 'open' : '') + ' ' + (isDropdownSelected ? 'selected' : ''))
          },
          _react2.default.createElement(
            'div',
            {
              className: _style2.default.dynamic([['2258481739', [_this2.props.itemsColorSelected, _this2.props.itemsColor]]]) + ' ' + 'text-label'
            },
            _react2.default.createElement(
              _plurallTexts.Text,
              {
                bold: '600',
                color: color
              },
              isDropdownSelected ? selected : list[0].label
            )
          ),
          !this.state.open && _react2.default.createElement(_plurallIcons.PureArrow, {
            color: selected !== list[0].label && !open ? '#FFFFFF' : '#00B083'
          })
        ),
        this.state.open && _react2.default.createElement(
          'div',
          {
            className: _style2.default.dynamic([['2258481739', [_this2.props.itemsColorSelected, _this2.props.itemsColor]]]) + ' ' + ('list box ' + (fadein ? 'fadeIn' : '') + ' ' + (fadeout ? 'fadeOut' : ''))
          },
          _react2.default.createElement(
            'div',
            {
              onClick: function onClick() {
                return _this2.close();
              },
              className: _style2.default.dynamic([['2258481739', [_this2.props.itemsColorSelected, _this2.props.itemsColor]]]) + ' ' + 'close'
            },
            _react2.default.createElement(_plurallIcons.Close, null)
          ),
          list.map(function (l) {
            if (l.value !== '') {
              return _react2.default.createElement(
                _plurallTexts.Text,
                {
                  bold: '600',
                  color: l.label === selected ? itemsColorSelected : itemsColor,
                  key: l.value
                },
                _react2.default.createElement(
                  'span',
                  {
                    style: { cursor: 'pointer' },
                    onClick: function onClick() {
                      return _this2.selectedItem(l);
                    },
                    className: _style2.default.dynamic([['2258481739', [_this2.props.itemsColorSelected, _this2.props.itemsColor]]])
                  },
                  l.label
                )
              );
            }
            return null;
          })
        ),
        _react2.default.createElement(_style2.default, {
          styleId: '2258481739',
          css: ['div.__jsx-style-dynamic-selector *.__jsx-style-dynamic-selector{box-sizing:border-box;}', '.holder.__jsx-style-dynamic-selector{position:relative;margin-right:1%;}', '.label.__jsx-style-dynamic-selector{cursor:pointer;-webkit-box-pack:justify;-webkit-justify-content:space-between;-ms-flex-pack:justify;justify-content:space-between;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:#ffffff;padding:15px;box-shadow:0 1px 2px 0 rgba(0,0,0,0.2);border-radius:10px;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-align-items:flex-start;-webkit-box-align:flex-start;-ms-flex-align:flex-start;align-items:flex-start;width:100%;z-index:2;}', '.list.__jsx-style-dynamic-selector{position:absolute;top:-15px;left:0;background-color:#ffffff;padding:65px 20px 20px 16px;border-radius:10px;box-shadow:0 1px 2px 0 rgba(0,0,0,0.2);z-index:1;width:125%;}', '.list.__jsx-style-dynamic-selector p{padding:5px 0;white-space:nowrap;display:block;}', '.list.__jsx-style-dynamic-selector p:hover{color:' + _this2.props.itemsColorSelected + ' !important;}', '.selected.__jsx-style-dynamic-selector{background:' + _this2.props.itemsColor + ';}', '.open.__jsx-style-dynamic-selector{box-shadow:none;position:relative;}', '.text-label.__jsx-style-dynamic-selector{margin-right:10px;}', '.close.__jsx-style-dynamic-selector{position:absolute;right:10px;top:30px;cursor:pointer;}', '.fadeIn.__jsx-style-dynamic-selector{-webkit-animation:fadein-__jsx-style-dynamic-selector .4s ease-in;animation:fadein-__jsx-style-dynamic-selector .4s ease-in;}', '.fadeOut.__jsx-style-dynamic-selector{-webkit-animation:fadeout-__jsx-style-dynamic-selector .4s ease-in;animation:fadeout-__jsx-style-dynamic-selector .4s ease-in;}', '@-webkit-keyframes fadein-__jsx-style-dynamic-selector{from{opacity:0;}to{opacity:1;}}', '@keyframes fadein-__jsx-style-dynamic-selector{from{opacity:0;}to{opacity:1;}}', '@-webkit-keyframes fadeout-__jsx-style-dynamic-selector{from{opacity:1;}to{opacity:0;}}', '@keyframes fadeout-__jsx-style-dynamic-selector{from{opacity:1;}to{opacity:0;}}'],
          dynamic: [_this2.props.itemsColorSelected, _this2.props.itemsColor]
        })
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  onClick: _propTypes2.default.func.isRequired,
  list: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  itemsColor: _propTypes2.default.string,
  itemsColorSelected: _propTypes2.default.string
};

Dropdown.defaultProps = {
  itemsColor: '#00B083',
  itemsColorSelected: '#888888'
};

exports.default = Dropdown;